<template>
  <v-container>
    <div>
      <h1>L'id : {{id}}</h1>
      <h1>Le price : {{price}}</h1>
      <h1>La date d'émission': {{pay_date}}</h1>
      <h1>La date de création : {{date_created}}</h1>
      <h1>Est payé? : {{is_pay}}</h1>
      <v-btn
          @click="deleteFacture()"
          color="error"
      >
        Supprimer le facture</v-btn>
      <v-dialog
          v-model="displayDialog"
          max-width="600px"
          :retain-focus="false"
      >
        <template v-slot:activator="{ on, attrs }">
          <v-btn
              color="warning"
              dark
              v-bind="attrs"
              v-on="on"
          >
            Modifier le Facture
          </v-btn>
        </template>
        <v-card>
          <v-form>
            <v-card-title>
              <span class="headline">Facture</span>
            </v-card-title>
            <v-card-text>
              <v-container>
                <v-row>
                  <v-col cols="12">
                    <v-text-field
                        v-model="dialog.price"
                        label="Prix*"
                        type="text"
                        required
                    ></v-text-field>
                  </v-col>
                  <v-col cols="12">
                    <v-text-field
                        v-model="dialog.pay_date"
                        label="date de payement*"
                        type="date"
                        required
                    ></v-text-field>
                  </v-col>
                </v-row>
              </v-container>
              <small>*L'étoile indique les champs requis</small>
            </v-card-text>
            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn
                  color="blue darken-1"
                  text
                  @click="displayDialog = false"
              >
                Fermer la fenêtre
              </v-btn>
              <v-btn
                  @click="displayDialog = false; updateFacture();"
                  color="blue darken-1"
              >
                Modifier
              </v-btn>
            </v-card-actions>
          </v-form>
        </v-card>
      </v-dialog>
    </div>
  </v-container>
</template>

<script>

export default {
price: "FactureComponent",
  props: {
    id: Number,
    price: Number,
    pay_date: {
      type: Date,
      default: new Date()
    },
    date_created: {
      type: Date,
      default: new Date()
    },
    is_pay: Boolean
  },
  data() {
    return {
      displayDialog: false,
      dialog: {
        price: '',
        pay_date: '',
        is_pay: ''
      }
    }
  },
  mounted() {
    console.log(this.id)
    console.log(this.price)
    console.log(this.pay_date)
    this.dialog.price = this.price
    this.dialog.pay_date = this.pay_date
    this.dialog.is_pay = this.is_pay
  },
  methods: {
    updateFacture() {
      this.$axios.patch(`/facture/${this.id}`, {price: this.dialog.price, pay_date: this.dialog.pay_date, is_pay: this.dialog.is_pay})
          .then(() => {
            this.$emit("updated")
          }).catch((erreur) => {
        console.log(erreur)
      })
    },

    deleteFacture() {
      this.$axios.delete(`/facture/${this.id}`)
          .then(response => {
            this.$emit("updated")
          }).catch((erreur) => {
        console.log(erreur)
      })
    }
  },
}
</script>

<style scoped>

</style>